DIR_INST=~/nsolid

#-------------------------------------------------------------------------------
# unpack
#-------------------------------------------------------------------------------

echo ""
echo "unpacking tarballs into ${DIR_INST}"

mkdir -p ${DIR_INST}
mkdir -p ${DIR_INST}/console
mkdir -p ${DIR_INST}/proxy
mkdir -p ${DIR_INST}/etcd

rm -rf   ${DIR_INST}/console/*
rm -rf   ${DIR_INST}/proxy/*
rm -rf   ${DIR_INST}/etcd/*

tar --strip-components 1 -zxf ./nsolid-v1.0.0-darwin-x64.tar.gz -C ${DIR_INST}
tar --strip-components 1 -zxf ./nsolid-console-v1.1.8-darwin-x64.tar.gz -C ${DIR_INST}/console
tar --strip-components 1 -zxf ./nsolid-proxy-v3.2.2.tar.gz -C ${DIR_INST}/proxy
tar --strip-components 1 -zxf ./etcd-v2.3.3-darwin-amd64.zip -C ${DIR_INST}/etcd

#-------------------------------------------------------------------------------
# write launch scripts
#-------------------------------------------------------------------------------

#--------------------------------------
echo "writing ${DIR_INST}/launch-etcd.sh"

cat > ${DIR_INST}/launch-etcd.sh << END_ETCD_SH
#!/bin/sh
cd ${DIR_INST}/etcd
./etcd
END_ETCD_SH

chmod +x ${DIR_INST}/launch-etcd.sh

#--------------------------------------
echo "writing ${DIR_INST}/launch-nsolid-console.sh"

cat > ${DIR_INST}/launch-nsolid-console.sh << END_CONSOLE_SH
#!/bin/sh
cd ${DIR_INST}/console
NODE_ENV=production ../bin/nsolid bin/nsolid-console --interval=3000
END_CONSOLE_SH

chmod +x ${DIR_INST}/launch-nsolid-console.sh

#--------------------------------------
echo "writing ${DIR_INST}/launch-nsolid-proxy.sh"

cat > ${DIR_INST}/launch-nsolid-proxy.sh << END_PROXY_SH
#!/bin/sh
cd ${DIR_INST}/proxy
../bin/nsolid proxy.js
END_PROXY_SH

chmod +x ${DIR_INST}/launch-nsolid-proxy.sh
