var spawn = require('child_process').spawn
var argv = require('yargs').argv
var path = require('path')

process.env.NSOLID_SOCKET = process.env.NSOLID_SOCKET || ':0'
process.env.NSOLID_HUB = process.env.NSOLID_HUB || '127.0.0.1:4001'
process.env.NSOLID_APPNAME = process.env.NSOLID_APPNAME || 'default-nsolid-scenario'

argv._.forEach(function (arg) {
  var parts = arg.split('@')
  var script = path.resolve(process.cwd(), parts[0])
  var count = parseInt(parts[1], 10)

  for (var i = 0; i < count; i++) {

    console.error('spawning %s (%s/%s)', path.basename(script), i, count - 1)
    spawn('nsolid', [script, '-i', i, '-c', count], {
      env: process.env,
      stdio: 'inherit'
    })
    .on('error', console.error)
    .on('exit', console.error)
  }
})

