module.exports = addProcess

function addProcess (process, host, getApp) {
  if (!host.memoryPercentageUsed) { // TODO: is this the right place?
    host.memoryPercentageUsed = ((host.totalmem - host.freemem) / host.totalmem) * 100
  }

  var application = getApp(process.app, {
    name: process.app
  })

  application.processes.push({
    id: process.id,
    app: process.app,
    pid: process.pid,
    uptime: process.uptime,
    starttime: Date.now() - (process.uptime * 1000),
    version: '',
    title: process.title,
    async: {
      handles: process.activeHandles || 0,
      streams: process.activeStreams || 0,
      requests: process.activeRequests || 0
    },

    memory: {
      rss: process.rss,
      total: process.heapTotal,
      used: process.heapUsed
    },

    graphs: {},

    host: host,
    snapshots: [],
    cpu: process.cpu
  })

  return application
}
