var merge = require('merge')

module.exports = createArrayStore

function createArrayStore (start) {
  var array = []
  var map = {}

  function getByName (name, value) {
    if (typeof map[name] === 'undefined') {
      var id = map[name] = array.length
      // TODO: optimize this for places where we do not need _id or time
      array.push(merge(true, {
        time: Date.now(),
        _id: id + 1
      }, start, value))
    } else {
      merge(array[map[name]], value)
    }

    return array[map[name]]
  }

  getByName.array = array
  getByName.has = function (name) {
    return !!map[name]
  }
  return getByName
}
