var merge = require('merge')
var camelize = require('camelize')

module.exports = intersect

// perform pairwise intersection on hosts or processeses
// basically anything two arrays that contain objects with the shape:
// { meta : { id: "something" } }

function intersect (a, b) {
  var valid = {}
  var pending = {}
  for (var i = 0; i < b.length; i++) {
    pending[b[i].meta.id] = b[i]
  }
  for (var j = 0; j < a.length; j++) {
    var key = a[j].meta.id
    if (pending[key]) {
      valid[key] = camelize(merge.recursive(a[j], pending[key]))
    }
  }
  return valid
}
